import org.gicentre.handy.*;
HandyRenderer h;
//item types: acbk, jcbk, arbk, jrbk (=

Table overall_data;
int rows, cols;
int a, b;
int originX = 250;
int originY = 500;
int max_checkout_size = 50;
int checkout_sane_size;
int checkout_size;
int hour;
float max;
float min;
int r ;
int initial_six_angle = 0;
float initial_angle = 0;
float theta;
// it should vary in the final version, right now it's set to 200.
float[][] data_matrix;
int[] data_sum;
int sum;
int sane_sum;
color stroke_colors[] = {#CE4C34,#13271C,#CE4C34,#13271C};
//all colors are ugly and tentative, red for adults, dark blue for juvenile

void setup() {
  size(720,720);
  h = new HandyRenderer(this);
  overall_data = loadTable("sql2016_merged.csv", "header");
  rows = overall_data.getRowCount();
  cols = overall_data.getColumnCount();
  data_matrix = new float[rows][cols-2];
  
  data_sum = new int[cols-2];
  
  for (int i=0; i<data_matrix.length; i++){
    //length: length of array
    for (int j=0; j<data_matrix[0].length; j++){
      data_matrix[i][j] = overall_data.getFloat(i,j+2);
    }
  }
  for (int j=0; j<data_matrix[0].length; j++){
      //length: length of array
      int sum = 0;
      for (int i=1; i<data_matrix.length; i++){
        sum += data_matrix[i][j];
      }
      sane_sum = int(log(sum*2))*20+10;
      data_sum[j] = sane_sum;
    }
  for (int i=1; i<data_matrix.length; i++){
    //length: length of array
    for (int j=0; j<data_matrix[0].length; j++){
      if(data_matrix[i][j] > max){
        max = data_matrix[i][j];
      }
    }
  }
    for (int i=1; i<data_matrix.length; i++){
    //length: length of array
    for (int j=0; j<data_matrix[0].length; j++){
      if(data_matrix[i][j] < min){
        min = data_matrix[i][j];
      }
    }
  }
  //above for loops by Rodger, slightly changed i from 0 to 1
}

void draw(){
//  noLoop();
  background(255);
  noFill();
  //for (int i=0;i<data_sum.length;i++){
  //    println(data_sum[i]);
  //  }
  // above for loop by Rodger, checking if data_sum is in correct format
  beginShape();
  for (int y=9;y<22;y++){
  r = data_sum[y];
  textSize(20);
  fill(0, 102, 153, 204);
  text(str(y),r*cos(initial_six_angle+(TWO_PI-initial_angle)*y/17)+originX, r*sin(initial_six_angle+(TWO_PI-initial_angle)*y/17)+originY);
  //fill(235,215,182);
  noFill();
  strokeWeight(1);
  curveVertex(r*cos(initial_six_angle+(TWO_PI-initial_angle)*y/17)+originX, r*sin(initial_six_angle+(TWO_PI-initial_angle)*y/17)+originY);
  line(originX,originY,r*cos(initial_six_angle+(TWO_PI-initial_angle)*y/17)+originX, r*sin(initial_six_angle+(TWO_PI-initial_angle)*y/17)+originY);
}
  endShape();
  for (int i=1; i<data_matrix.length; i++){
    //length: length of array
//    beginShape();
    stroke(stroke_colors[i-1]);
    for (int j=0; j<data_matrix[0].length; j++){
      checkout_size = (int)map(data_matrix[i][j],min,max,0,max_checkout_size);
      checkout_sane_size = int(40*log(checkout_size*5));
      //checkout_size denotes area of ellipse;
      //w the advice of Prof. Legrady, this mapping part was made more
      //sane by a log function,
      //plotting found here :https://www.desmos.com/calculator/ddjczywf9x
      a = floor(3*sqrt(checkout_sane_size)/2)+1;
      b = floor(checkout_sane_size*4/a);
      // a, b are parameters for drawing ellipse;
      r = data_sum[j];
      theta = initial_six_angle+(TWO_PI-initial_angle)*j/17;
      strokeWeight(0.5);
      fill(stroke_colors[i-1]);
      //arc(360,360,(checkout_sane_size)*cos(theta), (checkout_sane_size)*cos(theta), theta, theta+(checkout_sane_size/100));
      h.ellipse(r*cos(theta)+originX+random(-10,10), r*sin(theta)+originY+random(-10,10),b,a);
      //vertex(checkout_sane_size*cos(theta)+360, checkout_sane_size*sin(theta)+360);  
      // we set origin at (360,360)
    }
//    endShape();
  }
  strokeWeight(0.1);
  rect(360,360,5,5);
  save("7.png");
}
